lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [<thread-prev] [day] [month] [year] [list]
Message-ID: <5af799c3-5f39-9792-225e-1957c3da7b07@arm.com>
Date:   Tue, 9 Nov 2021 13:26:49 +0000
From:   German Gomez <german.gomez@....com>
To:     James Clark <james.clark@....com>, Leo Yan <leo.yan@...aro.org>
Cc:     linux-kernel@...r.kernel.org, linux-perf-users@...r.kernel.org,
        John Garry <john.garry@...wei.com>,
        Will Deacon <will@...nel.org>,
        Mathieu Poirier <mathieu.poirier@...aro.org>,
        Mark Rutland <mark.rutland@....com>,
        Alexander Shishkin <alexander.shishkin@...ux.intel.com>,
        Jiri Olsa <jolsa@...hat.com>,
        Namhyung Kim <namhyung@...nel.org>,
        Mike Leach <mike.leach@...aro.org>,
        linux-arm-kernel@...ts.infradead.org, coresight@...ts.linaro.org
Subject: Re: [PATCH 5/5] perf arm-spe: Snapshot mode test

Hi James, Leo,

Thank you for testing the patch.

On 02/11/2021 15:37, James Clark wrote:
> [...]
> Ok, it seems like I was relying on buggy dash behaviour for my original change. Even with this:
>
>         if [[ "$1" == "int" ]]; then
>                 kill -SIGINT $$
>         fi
>         if [[ "$1" == "term" ]]; then
>                 kill -SIGTERM $$
>         fi
>
> it still doesn't allow you to break out of running it in a while loop. This is only because of
> the exit code, rather than any kind of signal propagation. Actually it's possible to stop it
> with Ctrl-\ rather than Ctrl-C, and that doesn't require any extra handling in the script.
>
> For that reason I'm happy to go with Leo's original suggestion when I first added this which was
> to not have any extra kill at all.

Thanks for debugging the issue, I think I will consider this fix in the
re-submission.

Thanks,
German

>
> Another fix could be this, but I'm not too keen on it because I don't think any other tests behave
> like this:
>
>         [ "$1" = "int" ] || exit 1
>         [ "$1" = "term" ] || exit 1
>
>>>> +	exit $glb_err
>>>> +}
>>>> +
>>>> +trap cleanup_files exit term int
>>>> +
>>>> +arm_spe_report() {
>>>> +	if [ $2 != 0 ]; then
>>>> +		echo "$1: FAIL"
>>>> +		glb_err=$2
>>>> +	else
>>>> +		echo "$1: PASS"
>>>> +	fi
>>>> +}
>>>> +
>>>> +perf_script_samples() {
>>>> +	echo "Looking at perf.data file for dumping samples:"
>>>> +
>>>> +	# from arm-spe.c/arm_spe_synth_events()
>>>> +	events="(ld1-miss|ld1-access|llc-miss|lld-access|tlb-miss|tlb-access|branch-miss|remote-access|memory)"
>>>> +
>>>> +	# Below is an example of the samples dumping:
>>>> +	#	dd  3048 [002]          1    l1d-access:      ffffaa64999c __GI___libc_write+0x3c (/lib/aarch64-linux-gnu/libc-2.27.so)
>>>> +	#	dd  3048 [002]          1    tlb-access:      ffffaa64999c __GI___libc_write+0x3c (/lib/aarch64-linux-gnu/libc-2.27.so)
>>>> +	#	dd  3048 [002]          1        memory:      ffffaa64999c __GI___libc_write+0x3c (/lib/aarch64-linux-gnu/libc-2.27.so)
>>>> +	perf script -F,-time -i ${perfdata} 2>&1 | \
>>>> +		egrep " +$1 +[0-9]+ .* +${events}:(.*:)? +" > /dev/null 2>&1
>>>> +}
>>>> +
>>>> +perf_report_samples() {
>>>> +	echo "Looking at perf.data file for reporting samples:"
>>>> +
>>>> +	# Below is an example of the samples reporting:
>>>> +	#   73.04%    73.04%  dd    libc-2.27.so      [.] _dl_addr
>>>> +	#    7.71%     7.71%  dd    libc-2.27.so      [.] getenv
>>>> +	#    2.59%     2.59%  dd    ld-2.27.so        [.] strcmp
>>>> +	perf report --stdio -i ${perfdata} 2>&1 | \
>>>> +		egrep " +[0-9]+\.[0-9]+% +[0-9]+\.[0-9]+% +$1 " > /dev/null 2>&1
>>>> +}
>>>> +
>>>> +arm_spe_snapshot_test() {
>>>> +	echo "Recording trace with snapshot mode $perfdata"
>>>> +	perf record -o ${perfdata} -e arm_spe// -S \
>>>> +		-- dd if=/dev/zero of=/dev/null > /dev/null 2>&1 &
>>>> +	PERFPID=$!
>>>> +
>>>> +	# Wait for perf program
>>>> +	sleep 1
>>>> +
>>>> +	# Send signal to snapshot trace data
>>>> +	kill -USR2 $PERFPID
>>>> +
>>>> +	# Stop perf program
>>>> +	kill $PERFPID
>>>> +	wait $PERFPID
>>>> +
>>>> +	perf_script_samples dd &&
>>>> +	perf_report_samples dd
>>>> +
>>>> +	err=$?
>>>> +	arm_spe_report "SPE snapshot testing" $err
>>>> +}
>>>> +
>>>> +arm_spe_snapshot_test
>>>> +exit $glb_err
>>>> \ No newline at end of file
>>>> -- 
>>>> 2.17.1
>>>>

Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ